initial buildroot for linux 5.15

This commit is contained in:
Huan.Feng
2021-12-06 14:12:13 +08:00
parent d7767d594e
commit 7b6fc358fa
12736 changed files with 508822 additions and 0 deletions
+36
View File
@@ -0,0 +1,36 @@
#!/bin/sh
candidate="$1" #ignored
asciidoc=`which asciidoc`
if [ ! -x "$asciidoc" ]; then
# echo nothing: no suitable asciidoc found
exit 1
fi
# Output of 'asciidoc --version' examples:
# asciidoc 8.6.7
version=`$asciidoc --version | cut -d\ -f2`
major=`echo "$version" | cut -d. -f1`
minor=`echo "$version" | cut -d. -f2`
bugfix=`echo "$version" | cut -d. -f3`
# To generate the manual, we need asciidoc >= 8.6.3
major_min=8
minor_min=6
bugfix_min=3
if [ $major -gt $major_min ]; then
echo $asciidoc
else
if [ $major -eq $major_min -a $minor -ge $minor_min ]; then
echo $asciidoc
else
if [ $major -eq $major_min -a $minor -eq $minor_min \
-a $bugfix -ge $bugfix_min ]; then
echo $asciidoc
else
# echo nothing: no suitable asciidoc found
exit 1
fi
fi
fi
@@ -0,0 +1,14 @@
# If the system lacks bison or flex, add
# dependencies to suitable host packages
#
# BR2_{BISON,FLES}_HOST_DEPENDENCY should only be used to build code
# that runs on host, e.g. Kconfig. To build code for target use plain
# host-{bison,flex}.
ifeq ($(shell which bison 2>/dev/null),)
BR2_BISON_HOST_DEPENDENCY = host-bison
endif
ifeq ($(shell which flex 2>/dev/null),)
BR2_FLEX_HOST_DEPENDENCY = host-flex
endif
+14
View File
@@ -0,0 +1,14 @@
# Set this to either 3.16 or higher, depending on the highest minimum
# version required by any of the packages bundled in Buildroot. If a
# package is bumped or a new one added, and it requires a higher
# version, our cmake infra will catch it and build its own.
#
BR2_CMAKE_VERSION_MIN = 3.16
BR2_CMAKE_CANDIDATES ?= cmake cmake3
BR2_CMAKE ?= $(call suitable-host-package,cmake,\
$(BR2_CMAKE_VERSION_MIN) $(BR2_CMAKE_CANDIDATES))
ifeq ($(BR2_CMAKE),)
BR2_CMAKE = $(HOST_DIR)/bin/cmake
BR2_CMAKE_HOST_DEPENDENCY = host-cmake
endif
+45
View File
@@ -0,0 +1,45 @@
#!/bin/sh
# prevent shift error
[ $# -lt 2 ] && exit 1
major_min="${1%.*}"
minor_min="${1#*.}"
shift
for candidate; do
# Try to locate the candidate. Discard it if not located.
cmake=`which "${candidate}" 2>/dev/null`
[ -n "${cmake}" ] || continue
# Extract version X.Y from versions in the form X.Y or X.Y.Z
# with X, Y and Z numbers with one or more digits each, e.g.
# 3.2 -> 3.2
# 3.2.3 -> 3.2
# 3.2.42 -> 3.2
# 3.10 -> 3.10
# 3.10.4 -> 3.10
# 3.10.42 -> 3.10
# Discard the candidate if no version can be obtained
version="$(${cmake} --version \
|sed -r -e '/.* ([[:digit:]]+\.[[:digit:]]+).*$/!d;' \
-e 's//\1/'
)"
[ -n "${version}" ] || continue
major="${version%.*}"
minor="${version#*.}"
if [ ${major} -gt ${major_min} ]; then
echo "${cmake}"
exit
elif [ ${major} -eq ${major_min} -a ${minor} -ge ${minor_min} ]; then
echo "${cmake}"
exit
fi
done
# echo nothing: no suitable cmake found
exit 1
@@ -0,0 +1,6 @@
# Check whether the host's coreutils are up to date enough
# to provide 'ln --relative' and 'realpath'.
ifeq (,$(call suitable-host-package,coreutils))
BR2_COREUTILS_HOST_DEPENDENCY = host-coreutils
endif
+12
View File
@@ -0,0 +1,12 @@
#!/bin/sh
# Exit on the first error
set -e
# Does ln supports the --relative/-r option?
ln --relative --help >/dev/null 2>&1
# Does realpath exist?
realpath --help >/dev/null 2>&1
echo OK
+3
View File
@@ -0,0 +1,3 @@
ifeq (,$(call suitable-host-package,gzip))
BR2_GZIP_HOST_DEPENDENCY = host-gzip
endif
+21
View File
@@ -0,0 +1,21 @@
#!/bin/sh
candidate="$1" # ignored
gzip="$(which gzip)"
if [ ! -x "${gzip}" ]; then
# echo nothing: no suitable gzip found
exit 1
fi
# gzip displays its version string on stdout
# pigz displays its version string on stderr
version="$("${gzip}" --version 2>&1)"
case "${version}" in
(*pigz*)
# echo nothing: no suitable gzip found
exit 1
;;
esac
printf "%s" "${gzip}"
+4
View File
@@ -0,0 +1,4 @@
ifeq (,$(call suitable-host-package,lzip,$(LZCAT)))
BR2_LZIP_HOST_DEPENDENCY = host-lzip
LZCAT = $(HOST_DIR)/bin/lzip -d -c
endif
+14
View File
@@ -0,0 +1,14 @@
#!/bin/sh
candidate="$1"
lzip=`which $candidate 2>/dev/null`
if [ ! -x "$lzip" ]; then
lzip=`which lzip 2>/dev/null`
if [ ! -x "$lzip" ]; then
# echo nothing: no suitable lzip found
exit 1
fi
fi
echo $lzip
+21
View File
@@ -0,0 +1,21 @@
# Since version 2.28, glibc requires GNU Make >= 4.0
# https://www.sourceware.org/ml/libc-alpha/2018-08/msg00003.html
#
# Set this to either 4.0 or higher, depending on the highest minimum
# version required by any of the packages bundled in Buildroot. If a
# package is bumped or a new one added, and it requires a higher
# version, our package infra will catch it and whine.
#
BR2_MAKE_VERSION_MIN = 4.0
BR2_MAKE ?= $(call suitable-host-package,make,\
$(BR2_MAKE_VERSION_MIN) $(MAKE))
ifeq ($(BR2_MAKE),)
BR2_MAKE = $(HOST_DIR)/bin/host-make -j$(PARALLEL_JOBS)
BR2_MAKE1 = $(HOST_DIR)/bin/host-make -j1
BR2_MAKE_HOST_DEPENDENCY = host-make
else
BR2_MAKE = $(MAKE)
BR2_MAKE1 = $(MAKE1)
endif
+37
View File
@@ -0,0 +1,37 @@
#!/bin/sh
# prevent shift error
[ $# -lt 2 ] && exit 1
major_min="${1%.*}"
minor_min="${1#*.}"
shift
# The host make program is already checked by dependencies.sh but we
# want to check the version number even if Buildroot is able to use
# GNU make >= 3.81 but some packages may require a more recent version.
make="$1"
# Output of 'make --version' examples:
# GNU Make 4.2.1
# GNU Make 4.0
# GNU Make 3.81
version=`$make --version 2>&1 | sed -e 's/^.* \([0-9\.]\)/\1/g' -e 's/[-\
].*//g' -e '1q'`
major=`echo "$version" | cut -d. -f1`
minor=`echo "$version" | cut -d. -f2`
if [ $major -lt $major_min ]; then
# echo nothing: no suitable make found
exit 1
fi
if [ $major -eq $major_min -a $minor -lt $minor_min ]; then
# echo nothing: no suitable make found
exit 1
fi
# valid
echo $make
@@ -0,0 +1,8 @@
# Since version 2.29, glibc requires python 3.4 or later to build the GNU C Library.
# https://www.sourceware.org/ml/libc-alpha/2019-01/msg00723.html
BR2_PYTHON3_VERSION_MIN = 3.4
ifeq (,$(call suitable-host-package,python3,$(BR2_PYTHON3_VERSION_MIN) python3 python))
BR2_PYTHON3_HOST_DEPENDENCY = host-python3
endif
+31
View File
@@ -0,0 +1,31 @@
#!/bin/sh
# prevent shift error
[ $# -lt 2 ] && exit 1
version_min="$(echo ${1} | awk '{ split($1, v, "."); print v[1] v[2] }')"
shift
# The host python interpreter is already checked by dependencies.sh but
# it only check if the version is at least 2.7.
# We want to check the version number of the python3 interpreter even
# if Buildroot is able to use any version but some packages may require
# a more recent version.
for candidate in "${@}" ; do
python3=`which $candidate 2>/dev/null`
if [ ! -x "$python3" ]; then
continue
fi
version=`$python3 -V 2>&1 | awk '{ split($2, v, "."); print v[1] v[2] }'`
if [ $version -lt $version_min ]; then
# no suitable python3 found
continue
fi
# suitable python3 found
echo $python3
break
done
+6
View File
@@ -0,0 +1,6 @@
TAR ?= tar
ifeq (,$(call suitable-host-package,tar,$(TAR)))
TAR = $(HOST_DIR)/bin/tar
BR2_TAR_HOST_DEPENDENCY = host-tar
endif
+47
View File
@@ -0,0 +1,47 @@
#!/bin/sh
candidate="$1"
tar=`which $candidate`
if [ ! -x "$tar" ]; then
tar=`which tar`
if [ ! -x "$tar" ]; then
# echo nothing: no suitable tar found
exit 1
fi
fi
# Output of 'tar --version' examples:
# tar (GNU tar) 1.15.1
# tar (GNU tar) 1.25
# bsdtar 2.8.3 - libarchive 2.8.3
version=`$tar --version | head -n 1 | sed 's/^.*\s\([0-9]\+\.\S\+\).*$/\1/'`
major=`echo "$version" | cut -d. -f1`
minor=`echo "$version" | cut -d. -f2`
bugfix=`echo "$version" | cut -d. -f3`
version_bsd=`$tar --version | grep 'bsdtar'`
# BSD tar does not have all the command-line options
if [ -n "${version_bsd}" ] ; then
# echo nothing: no suitable tar found
exit 1
fi
# Minimal version = 1.27 (previous versions do not correctly unpack archives
# containing hard-links if the --strip-components option is used or create
# different gnu long link headers for path elements > 100 characters).
major_min=1
minor_min=27
if [ $major -lt $major_min ]; then
# echo nothing: no suitable tar found
exit 1
fi
if [ $major -eq $major_min -a $minor -lt $minor_min ]; then
# echo nothing: no suitable tar found
exit 1
fi
# valid
echo $tar
+7
View File
@@ -0,0 +1,7 @@
# XZCAT is taken from BR2_XZCAT (defaults to 'xzcat') (see Makefile)
# If it is not present, build our own host-xzcat
ifeq (,$(call suitable-host-package,xzcat,$(XZCAT)))
BR2_XZCAT_HOST_DEPENDENCY = host-xz
XZCAT = $(HOST_DIR)/bin/xzcat
endif
+14
View File
@@ -0,0 +1,14 @@
#!/bin/sh
candidate="$1"
xzcat=`which $candidate 2>/dev/null`
if [ ! -x "$xzcat" ]; then
xzcat=`which xzcat 2>/dev/null`
if [ ! -x "$xzcat" ]; then
# echo nothing: no suitable xzcat found
exit 1
fi
fi
echo $xzcat
+35
View File
@@ -0,0 +1,35 @@
################################################################################
#
# Check buildroot dependencies and bail out if the user's
# system is judged to be lacking....
#
################################################################################
ifeq ($(BR2_FORCE_HOST_BUILD),y)
# ignore all available host packages
define suitable-host-package
endef
else
# suitable-host-pkg: calls check-host-$(1).sh shell script. Parameter (2)
# can be the candidate to be checked. If not present, the check-host-$(1).sh
# script should use 'which' to find a candidate. The script should return
# the path to the suitable host tool, or nothing if no suitable tool was found.
define suitable-host-package
$(if $(1),$(shell support/dependencies/check-host-$(1).sh $(2)))
endef
endif
# host utilities needs host-tar to extract the source code tarballs, so
# ensure check-host-tar.mk is included before the rest
include support/dependencies/check-host-tar.mk
-include $(sort $(filter-out %-tar.mk,$(wildcard support/dependencies/check-host-*.mk)))
dependencies:
@MAKE="$(MAKE)" DL_TOOLS="$(sort $(DL_TOOLS_DEPENDENCIES))" \
$(TOPDIR)/support/dependencies/dependencies.sh
################################################################################
#
# Toplevel Makefile options
#
################################################################################
.PHONY: dependencies
+306
View File
@@ -0,0 +1,306 @@
#!/bin/sh
# vi: set sw=4 ts=4:
export LC_ALL=C
TAB="$(printf '\t')"
NL="
"
# Verify that grep works
echo "WORKS" | grep "WORKS" >/dev/null 2>&1
if test $? != 0 ; then
echo
echo "grep doesn't work"
exit 1
fi
# Sanity check for CWD in LD_LIBRARY_PATH
case ":${LD_LIBRARY_PATH:-unset}:" in
(*::*|*:.:*)
echo
echo "You seem to have the current working directory in your"
echo "LD_LIBRARY_PATH environment variable. This doesn't work."
exit 1
;;
esac
# Sanity check for CWD in PATH. Having the current working directory
# in the PATH makes various packages (e.g. toolchain, coreutils...)
# build process break.
# PATH should not contain a newline, otherwise it fails in spectacular
# ways as soon as PATH is referenced in a package rule
# An empty PATH is technically possible, but in practice we would not
# even arrive here if that was the case.
case ":${PATH:-unset}:" in
(*::*|*:.:*)
echo
echo "You seem to have the current working directory in your"
echo "PATH environment variable. This doesn't work."
exit 1
;;
(*" "*|*"${TAB}"*|*"${NL}"*)
printf "\n"
printf "Your PATH contains spaces, TABs, and/or newline (\\\n) characters.\n"
printf "This doesn't work. Fix you PATH.\n"
exit 1
;;
esac
if test -n "$PERL_MM_OPT" ; then
echo
echo "You have PERL_MM_OPT defined because Perl local::lib"
echo "is installed on your system. Please unset this variable"
echo "before starting Buildroot, otherwise the compilation of"
echo "Perl related packages will fail"
exit 1
fi
check_prog_host()
{
prog="$1"
if ! which $prog > /dev/null ; then
echo >&2
echo "You must install '$prog' on your build machine" >&2
exit 1
fi
}
# Verify that which is installed
check_prog_host "which"
# Verify that sed is installed
check_prog_host "sed"
# 'file' must be present and must be exactly /usr/bin/file,
# otherwise libtool fails in incomprehensible ways.
check_prog_host "/usr/bin/file"
# Check make
MAKE=$(which make 2> /dev/null)
if [ -z "$MAKE" ] ; then
echo
echo "You must install 'make' on your build machine";
exit 1;
fi;
MAKE_VERSION=$($MAKE --version 2>&1 | sed -e 's/^.* \([0-9\.]\)/\1/g' -e 's/[-\ ].*//g' -e '1q')
if [ -z "$MAKE_VERSION" ] ; then
echo
echo "You must install 'make' on your build machine";
exit 1;
fi;
MAKE_MAJOR=$(echo $MAKE_VERSION | sed -e "s/\..*//g")
MAKE_MINOR=$(echo $MAKE_VERSION | sed -e "s/^$MAKE_MAJOR\.//g" -e "s/\..*//g" -e "s/[a-zA-Z].*//g")
if [ $MAKE_MAJOR -lt 3 ] || [ $MAKE_MAJOR -eq 3 -a $MAKE_MINOR -lt 81 ] ; then
echo
echo "You have make '$MAKE_VERSION' installed. GNU make >=3.81 is required"
exit 1;
fi;
# Check host gcc
COMPILER=$(which $HOSTCC_NOCCACHE 2> /dev/null)
if [ -z "$COMPILER" ] ; then
COMPILER=$(which cc 2> /dev/null)
fi;
if [ -z "$COMPILER" ] ; then
echo
echo "You must install 'gcc' on your build machine";
exit 1;
fi;
COMPILER_VERSION=$($COMPILER -v 2>&1 | sed -n '/^gcc version/p' |
sed -e 's/^gcc version \([0-9\.]\)/\1/g' -e 's/[-\ ].*//g' -e '1q')
if [ -z "$COMPILER_VERSION" ] ; then
echo
echo "You must install 'gcc' on your build machine";
exit 1;
fi;
COMPILER_MAJOR=$(echo $COMPILER_VERSION | sed -e "s/\..*//g")
COMPILER_MINOR=$(echo $COMPILER_VERSION | sed -e "s/^$COMPILER_MAJOR\.//g" -e "s/\..*//g")
if [ $COMPILER_MAJOR -lt 4 -o $COMPILER_MAJOR -eq 4 -a $COMPILER_MINOR -lt 8 ] ; then
echo
echo "You have gcc '$COMPILER_VERSION' installed. gcc >= 4.8 is required"
exit 1;
fi;
# check for host CXX
CXXCOMPILER=$(which $HOSTCXX_NOCCACHE 2> /dev/null)
if [ -z "$CXXCOMPILER" ] ; then
CXXCOMPILER=$(which c++ 2> /dev/null)
fi
if [ -z "$CXXCOMPILER" ] ; then
echo
echo "You may have to install 'g++' on your build machine"
fi
if [ ! -z "$CXXCOMPILER" ] ; then
CXXCOMPILER_VERSION=$($CXXCOMPILER -v 2>&1 | sed -n '/^gcc version/p' |
sed -e 's/^gcc version \([0-9\.]\)/\1/g' -e 's/[-\ ].*//g' -e '1q')
if [ -z "$CXXCOMPILER_VERSION" ] ; then
echo
echo "You may have to install 'g++' on your build machine"
fi
fi
if [ -n "$CXXCOMPILER_VERSION" ] ; then
CXXCOMPILER_MAJOR=$(echo $CXXCOMPILER_VERSION | sed -e "s/\..*//g")
CXXCOMPILER_MINOR=$(echo $CXXCOMPILER_VERSION | sed -e "s/^$CXXCOMPILER_MAJOR\.//g" -e "s/\..*//g")
if [ $CXXCOMPILER_MAJOR -lt 4 -o $CXXCOMPILER_MAJOR -eq 4 -a $CXXCOMPILER_MINOR -lt 8 ] ; then
echo
echo "You have g++ '$CXXCOMPILER_VERSION' installed. g++ >= 4.8 is required"
exit 1
fi
fi
# Check bash
# We only check bash is available, setting SHELL appropriately is done
# in the top-level Makefile, and we mimick the same sequence here
if [ -n "${BASH}" ]; then :
elif [ -x /bin/bash ]; then :
elif [ -z "$( sh -c 'echo $BASH' )" ]; then
echo
echo "You must install 'bash' on your build machine"
exit 1
fi
# Check that a few mandatory programs are installed
missing_progs="no"
for prog in perl tar wget cpio unzip rsync bc ${DL_TOOLS} ; do
if ! which $prog > /dev/null ; then
echo "You must install '$prog' on your build machine";
missing_progs="yes"
if test $prog = "svn" ; then
echo " svn is usually part of the subversion package in your distribution"
elif test $prog = "hg" ; then
echo " hg is usually part of the mercurial package in your distribution"
elif test $prog = "zcat" ; then
echo " zcat is usually part of the gzip package in your distribution"
elif test $prog = "bzcat" ; then
echo " bzcat is usually part of the bzip2 package in your distribution"
fi
fi
done
if test "${missing_progs}" = "yes" ; then
exit 1
fi
PATCH_VERSION="$(patch -v 2>/dev/null | sed -n 's/^GNU patch \(.*\)/\1/p')"
if [ -z "${PATCH_VERSION}" ] ; then
echo
echo "You must install GNU patch"
exit 1
fi
PATCH_MAJOR="$(echo "${PATCH_VERSION}" | cut -d . -f 1)"
PATCH_MINOR="$(echo "${PATCH_VERSION}" | cut -d . -f 2)"
if [ "${PATCH_MAJOR}" -lt 2 ] || [ "${PATCH_MAJOR}" -eq 2 -a "${PATCH_MINOR}" -lt 7 ] ; then
echo
echo "You have GNU patch '${PATCH_VERSION}' installed. GNU patch >= 2.7 is required"
exit 1;
fi
if grep ^BR2_NEEDS_HOST_UTF8_LOCALE=y $BR2_CONFIG > /dev/null; then
if ! which locale > /dev/null ; then
echo
echo "You need locale support on your build machine to build a toolchain supporting locales"
exit 1 ;
fi
if ! locale -a | grep -q -i -E 'utf-?8$' ; then
echo
echo "You need at least one UTF8 locale to build a toolchain supporting locales"
exit 1 ;
fi
fi
if grep -q ^BR2_NEEDS_HOST_JAVA=y $BR2_CONFIG ; then
check_prog_host "java"
JAVA_GCJ=$(java -version 2>&1 | grep gcj)
if [ ! -z "$JAVA_GCJ" ] ; then
echo
echo "$JAVA_GCJ is not sufficient to compile your package selection."
echo "Please install an OpenJDK/IcedTea/Oracle Java."
exit 1 ;
fi
fi
if grep -q ^BR2_HOSTARCH_NEEDS_IA32_LIBS=y $BR2_CONFIG ; then
if test ! -f /lib/ld-linux.so.2 ; then
echo
echo "Your Buildroot configuration uses pre-built tools for the x86 architecture,"
echo "but your build machine uses the x86-64 architecture without the 32 bits compatibility"
echo "library."
echo "If you're running a Debian/Ubuntu distribution, install the libc6-i386,"
echo "lib32stdc++6, and lib32z1 packages (or alternatively libc6:i386,"
echo "libstdc++6:i386, and zlib1g:i386)."
echo "If you're running a RedHat/Fedora distribution, install the glibc.i686 and"
echo "zlib.i686 packages."
echo "If you're running an ArchLinux distribution, install lib32-glibc."
echo "For other distributions, refer to the documentation on how to install the 32 bits"
echo "compatibility libraries."
exit 1
fi
fi
if grep -q ^BR2_HOSTARCH_NEEDS_IA32_COMPILER=y $BR2_CONFIG ; then
if ! echo "int main(void) {}" | gcc -m32 -x c - -o /dev/null 2>/dev/null; then
echo
echo "Your Buildroot configuration needs a compiler capable of building 32 bits binaries."
echo "If you're running a Debian/Ubuntu distribution, install the gcc-multilib package."
echo "For other distributions, refer to their documentation."
exit 1
fi
if ! echo "int main(void) {}" | g++ -m32 -x c++ - -o /dev/null 2>/dev/null; then
echo
echo "Your Buildroot configuration needs a compiler capable of building 32 bits binaries."
echo "If you're running a Debian/Ubuntu distribution, install the g++-multilib package."
echo "For other distributions, refer to their documentation."
exit 1
fi
fi
if grep ^BR2_NEEDS_HOST_GCC_PLUGIN_SUPPORT=y $BR2_CONFIG ; then
if ! echo "#include <gcc-plugin.h>" | $HOSTCXX_NOCCACHE -I$($HOSTCXX_NOCCACHE -print-file-name=plugin)/include -x c++ -c - -o /dev/null ; then
echo
echo "Your Buildroot configuration needs a host compiler capable of building gcc plugins."
echo "If you're running a Debian/Ubuntu distribution, install gcc-X-plugin-dev package."
echo "For other distributions, refer to their documentation."
exit 1 ;
fi
fi
# Check that the Perl installation is complete enough for Buildroot.
required_perl_modules="Data::Dumper" # Needed to build host-autoconf
required_perl_modules="$required_perl_modules ExtUtils::MakeMaker" # Used by host-libxml-parser-perl
required_perl_modules="$required_perl_modules Thread::Queue" # Used by host-automake
if grep -q ^BR2_PACKAGE_MPV=y $BR2_CONFIG ; then
required_perl_modules="$required_perl_modules Math::BigInt"
required_perl_modules="$required_perl_modules Math::BigRat"
fi
if grep -q ^BR2_PACKAGE_WHOIS=y $BR2_CONFIG ; then
required_perl_modules="$required_perl_modules autodie"
fi
if grep -q -E '^BR2_PACKAGE_(WEBKITGTK|WPEWEBKIT)=y' $BR2_CONFIG ; then
required_perl_modules="${required_perl_modules} JSON::PP"
fi
# This variable will keep the modules that are missing in your system.
missing_perl_modules=""
for pm in $required_perl_modules ; do
if ! perl -e "require $pm" > /dev/null 2>&1 ; then
missing_perl_modules="$missing_perl_modules $pm"
fi
done
if [ -n "$missing_perl_modules" ] ; then
echo "Your Perl installation is not complete enough; at least the following"
echo "modules are missing:"
echo
for pm in $missing_perl_modules ; do
printf "\t $pm\n"
done
echo
exit 1
fi